/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 778 $ $LastChangedDate: 2002-08-31 18:14:23 +0200 (Sat, 31 Aug 2002) $
 *
 * Standard library for Gont, Sys module C implementation.
 */

#include <gont/runtime.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/times.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>

int Sys___get_argc(void)
{
	return gont_argc;
}

struct gont_string *Sys___get_argv(gont_ptroff idx)
{
	return gont_cstring(gont_argv[idx]);
}

void **Sys__times(void)
{
	struct tms t;
	if (times(&t) == (clock_t) -1)
		gont_sys_error(errno);
	return gont_make_tuple(2, (void*) t.tms_utime, (void*)t.tms_stime);
}

gont_ptroff Sys__clk_tck(void)
{
	return sysconf(_SC_CLK_TCK);
}

/* Moved from stdc.c */
void Sys__exit(gont_ptroff x)
{
	gont_run_exit_routines();
	exit(x);
}

void Sys__at_exit(struct gont_lambda_exp *fnc)
{
	gont_register_exit_routine((void (*)(void*))fnc->fnc, fnc->closure);
}

gont_ptroff Sys__shell(struct gont_string *s)
{
	int r;

	r = system(s->data);

	if (r == -1)
		gont_sys_error(errno);
	
	return WEXITSTATUS(r);
}

gont_ptroff Sys__isatty(gont_ptroff fd)
{
	return isatty(fd);
}
